// KDE includes
#include <kparts/part.h>
#include <klibloader.h>
#include <kde_terminal_interface.h>
#include <QTimer>

#include "term.h"

term::term (QWidget *parent) : QWidget (parent) {
    KParts::ReadOnlyPart *konsole_part = 0;     // the actual part pointer
    if ( konsole_part == 0L ) {  // konsole part is not yet loaded
        KLibFactory * factory = KLibLoader::self()->factory( "libkonsolepart" );
        if ( factory ) {
            // Create the part
            konsole_part = ( KParts::ReadOnlyPart * ) factory->create(this, "konsolepart",
                    "KParts::ReadOnlyPart" );
            t = (TerminalInterface *) konsole_part;
            connect( konsole_part, SIGNAL( processExited(int) ), this, SLOT( exit(int) ) );
        } else
            konsole_part = 0L;
    }
}

void term::start (QString &a_prg, QStringList &a_list) {
    if (!t) {
        printf ("We have some problem scotty\n");
    } else {
        prg = a_prg;
        list = a_list;
    }
    QTimer::singleShot (0, this, SLOT (startProgram(void)));
}

void term::exit (int code) {
    printf ("process exited %d\n", code);
}

void term::startProgram(void)
{
    printf ("Starting program from timer\n");
    t->startProgram (prg, list);
    printf ("Finished calling\n");
}
